/***********************************************
 *
 * OG Script Dumper v3.0 by learn_more
 * File: out\a190\script\cam_dump.as
 * Generated: 20-Aug-2012 19:53:28
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3c3550 (0x7c3550)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xbfb10 (0x4bfb10)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xbfb40 (0x4bfb40)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c39d0 (0x7c39d0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3c4110 (0x7c4110)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3ea0 (0x7c3ea0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3d90 (0x7c3d90)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c4170 (0x7c4170)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3c3c60 (0x7c3c60)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c3980 (0x7c3980)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c4140 (0x7c4140)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3c3a00 (0x7c3a00)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3c3b30 (0x7c3b30)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3c35a0 (0x7c35a0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3c30a0 (0x7c30a0)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x255be0 (0x655be0)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x254a70 (0x654a70)
	void RemoveAll();		// 'Overgrowth.exe' + 0x2549c0 (0x6549c0)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x254ad0 (0x654ad0)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x2559f0 (0x6559f0)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x255a60 (0x655a60)
	void Update();		// 'Overgrowth.exe' + 0x25a380 (0x65a380)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2b5ba0 (0x6b5ba0)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2b5b50 (0x6b5b50)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x389700 (0x789700)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x389560 (0x789560)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x3894f0 (0x7894f0)
	float GetLens();		// 'Overgrowth.exe' + 0x389540 (0x789540)
	void Update();		// 'Overgrowth.exe' + 0x389b80 (0x789b80)
	bool valid();		// 'Overgrowth.exe' + 0x387ac0 (0x787ac0)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x20f7b820
SphereCollision sphere_col;		// 0x20f7b824
GUI gui;		// 0x20f00090
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x447cc4 (0x847cc4)
CameraObject co;		// 0x1cb1d0f0
CameraAnimationReader camera_animation_reader;		// 0x1cb1d1dc
