/***********************************************
 *
 * OG Script Dumper v3.0 by learn_more
 * File: out\a190\script\playercontrol_dump.as
 * Generated: 20-Aug-2012 19:53:28
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// enemycontrol.as
	// aschar.as
	// situationawareness.as
	// interpdirection.as
	// aircontrols.as
	// fliproll.as
	// ledgegrab.as
	// playercontrol.as


/***********************************************
 * Global Functions:
 */

NavPath __cdecl GetPath(vec3, vec3)			// 'Overgrowth.exe' + 0x254f80 (0x654f80)
vec3 __cdecl NavRaycast(vec3, vec3)			// 'Overgrowth.exe' + 0x254970 (0x654970)
vec3 __cdecl NavPoint(vec3)			// 'Overgrowth.exe' + 0x254930 (0x654930)
void __cdecl SendMessage(int, int, vec3, vec3)			// 'Overgrowth.exe' + 0x255860 (0x655860)
void __cdecl SendMessage(int, string)			// 'Overgrowth.exe' + 0x256930 (0x656930)
vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3c3550 (0x7c3550)


/***********************************************
 * Objects:
 */

class Level
{		// size: 0x0, flags:  asOBJ_REF
	int QueryIntFunction(string);		// 'Overgrowth.exe' + 0x3c0540 (0x7c0540)
	int GetNumObjectives();		// 'Overgrowth.exe' + 0x3bff60 (0x7bff60)
	int GetNumAchievements();		// 'Overgrowth.exe' + 0x3bff30 (0x7bff30)
	const string &GetObjective(int);		// 'Overgrowth.exe' + 0x3c0310 (0x7c0310)
	const string &GetAchievement(int);		// 'Overgrowth.exe' + 0x3c0220 (0x7c0220)
	void Execute(string);		// 'Overgrowth.exe' + 0x3bff90 (0x7bff90)
};

class NavPath
{		// size: 0x14, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	bool success;		// byteOffset: 0x10
//-----
	int NumPoints();		// 'Overgrowth.exe' + 0x3c5260 (0x7c5260)
	vec3 GetPoint(int);		// 'Overgrowth.exe' + 0x3c5280 (0x7c5280)
};

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xbfb10 (0x4bfb10)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xbfb40 (0x4bfb40)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c39d0 (0x7c39d0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3c4110 (0x7c4110)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3ea0 (0x7c3ea0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3d90 (0x7c3d90)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c4170 (0x7c4170)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3c3c60 (0x7c3c60)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c3980 (0x7c3980)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c4140 (0x7c4140)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3c3a00 (0x7c3a00)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3c3b30 (0x7c3b30)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3c35a0 (0x7c35a0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3c30a0 (0x7c30a0)
};

class CharacterScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x3c1640 (0x7c1640)
	string GetObjPath();		// 'Overgrowth.exe' + 0x3c1230 (0x7c1230)
	string GetSkeletonPath();		// 'Overgrowth.exe' + 0x3c1200 (0x7c1200)
	string GetAnimPath(string);		// 'Overgrowth.exe' + 0x3c1530 (0x7c1530)
	string GetAttackPath(string);		// 'Overgrowth.exe' + 0x3c1420 (0x7c1420)
	void GetTeamString(string &out);		// 'Overgrowth.exe' + 0x3c1260 (0x7c1260)
	float GetHearing();		// 'Overgrowth.exe' + 0x3c11c0 (0x7c11c0)
};

class ReactionScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x3bf430 (0x7bf430)
	string GetAnimPath(float);		// 'Overgrowth.exe' + 0x3bf400 (0x7bf400)
	int GetMirrored();		// 'Overgrowth.exe' + 0x3bf3e0 (0x7bf3e0)
};

class AttackScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x23be80 (0x63be80)
	string GetPath();		// 'Overgrowth.exe' + 0x23b850 (0x63b850)
	string GetSpecial();		// 'Overgrowth.exe' + 0x23bca0 (0x63bca0)
	string GetUnblockedAnimPath();		// 'Overgrowth.exe' + 0x23bd60 (0x63bd60)
	string GetBlockedAnimPath();		// 'Overgrowth.exe' + 0x23bd30 (0x63bd30)
	string GetThrowAnimPath();		// 'Overgrowth.exe' + 0x23bd00 (0x63bd00)
	string GetThrownAnimPath();		// 'Overgrowth.exe' + 0x23bcd0 (0x63bcd0)
	string GetThrownCounterAnimPath();		// 'Overgrowth.exe' + 0x23b880 (0x63b880)
	int IsThrow();		// 'Overgrowth.exe' + 0x23b980 (0x63b980)
	int GetHeight();		// 'Overgrowth.exe' + 0x23bc90 (0x63bc90)
	vec3 GetCutPlane();		// 'Overgrowth.exe' + 0x23b960 (0x63b960)
	int GetCutPlaneType();		// 'Overgrowth.exe' + 0x23b950 (0x63b950)
	bool HasCutPlane();		// 'Overgrowth.exe' + 0x23b940 (0x63b940)
	vec3 GetStabDir();		// 'Overgrowth.exe' + 0x23b920 (0x63b920)
	int GetStabDirType();		// 'Overgrowth.exe' + 0x23b910 (0x63b910)
	bool HasStabDir();		// 'Overgrowth.exe' + 0x23b900 (0x63b900)
	int GetDirection();		// 'Overgrowth.exe' + 0x23bc80 (0x63bc80)
	int GetSwapStance();		// 'Overgrowth.exe' + 0x23bc70 (0x63bc70)
	int GetSwapStanceBlocked();		// 'Overgrowth.exe' + 0x23bc60 (0x63bc60)
	int GetUnblockable();		// 'Overgrowth.exe' + 0x23bc50 (0x63bc50)
	int GetFleshUnblockable();		// 'Overgrowth.exe' + 0x23b8f0 (0x63b8f0)
	int GetAsLayer();		// 'Overgrowth.exe' + 0x23b8e0 (0x63b8e0)
	string GetAlternate();		// 'Overgrowth.exe' + 0x23b8b0 (0x63b8b0)
	string GetReactionPath();		// 'Overgrowth.exe' + 0x23bbc0 (0x63bbc0)
	string GetMaterialEvent();		// 'Overgrowth.exe' + 0x23bc20 (0x63bc20)
	vec3 GetImpactDir();		// 'Overgrowth.exe' + 0x23bd90 (0x63bd90)
	float GetBlockDamage();		// 'Overgrowth.exe' + 0x23bb40 (0x63bb40)
	float GetSharpDamage();		// 'Overgrowth.exe' + 0x23bac0 (0x63bac0)
	float GetDamage();		// 'Overgrowth.exe' + 0x23ba40 (0x63ba40)
	float GetForce();		// 'Overgrowth.exe' + 0x23b9c0 (0x63b9c0)
	int GetMirrored();		// 'Overgrowth.exe' + 0x23b840 (0x63b840)
	int GetMobile();		// 'Overgrowth.exe' + 0x23b9b0 (0x63b9b0)
};

class PathScriptReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	int GetNearestPoint(vec3);		// 'Overgrowth.exe' + 0x3bfb20 (0x7bfb20)
	vec3 GetPointPosition(int);		// 'Overgrowth.exe' + 0x3bfb00 (0x7bfb00)
	int GetConnectedPoint(int);		// 'Overgrowth.exe' + 0x3bfae0 (0x7bfae0)
	int GetOtherConnectedPoint(int, int);		// 'Overgrowth.exe' + 0x3bfac0 (0x7bfac0)
};



/***********************************************
 * Global Properties:
 */

Level level;		// 'Overgrowth.exe' + 0x54c698 (0x94c698)
int _plant_movement_msg;		// 'Overgrowth.exe' + 0x447e70 (0x847e70)
int _editor_msg;		// 'Overgrowth.exe' + 0x447e74 (0x847e74)
ScriptParams params;		// 0x17db40e4
ASCollisions col;		// 0x17cf8000
SphereCollision sphere_col;		// 0x17cf8004
MovementObject this_mo;		// 0x17db4070
int _at_grip;		// 'Overgrowth.exe' + 0x4c7614 (0x8c7614)
int _at_sheathe;		// 'Overgrowth.exe' + 0x4c7618 (0x8c7618)
uint8 _ANM_MIRRORED;		// 'Overgrowth.exe' + 0x4c761c (0x8c761c)
uint8 _ANM_MOBILE;		// 'Overgrowth.exe' + 0x4c761d (0x8c761d)
uint8 _ANM_SUPER_MOBILE;		// 'Overgrowth.exe' + 0x4c761e (0x8c761e)
uint8 _ANM_SWAP;		// 'Overgrowth.exe' + 0x4c761f (0x8c761f)
uint8 _ANM_FROM_START;		// 'Overgrowth.exe' + 0x4c7620 (0x8c7620)
CharacterScriptGetter character_getter;		// 0x17db41fc
ReactionScriptGetter reaction_getter;		// 0x17db4160
AttackScriptGetter attack_getter;		// 0x17db4184
const int _high; // = 0
const int _medium; // = 1
const int _low; // = 2
const int _right; // = 0
const int _front; // = 1
const int _left; // = 2
AttackScriptGetter attack_getter2;		// 0x17db41c0
PathScriptReader path_script_reader;		// 0x17db4210
